/* added by shinichiro.h in 020820 */

#include "replay.h"

#include <stdlib.h>
#include <stdio.h>

enum { CHUNK = 0x1fff, END_REPLAY = 0xfe };

void init_replay(replay_t* rep) {
  rep->count = 0;
  rep->index = -1;
}

void quit_replay(replay_t* rep) {
  int i;
  for (i = 0; i <= rep->index; i++) {
	free(rep->vals[i]);
  }
}

void push_replay(replay_t* rep, unsigned char val) {
  /* CHUNK̐ƂɃm */
  if ((rep->count & CHUNK) == 0) {
	rep->count = 0;
	rep->index++;
	rep->vals[rep->index] =
	  (unsigned char*)malloc(sizeof(unsigned char) * CHUNK);
  }

  rep->vals[rep->index][rep->count] = val;
  rep->count++;
}

unsigned char pop_replay(replay_t* rep) {
  unsigned char ret;

  if ((rep->count & CHUNK) == 0) {
	rep->count = 0;
	rep->index++;
  }

  ret = rep->vals[rep->index][rep->count];
  rep->count++;

  return ret;
}

void save_replay(replay_t* rep, FILE* fp) {
  int i, j;
  for (i = 0; i < rep->index; i++) {
	for (j = 0; j < CHUNK; j++) {
	  fputc(rep->vals[i][j], fp);
	}
  }
  for (j = 0; j < rep->count; j++) {
	fputc(rep->vals[i][j], fp);
  }
  fputc(END_REPLAY, fp);
}

void load_replay(replay_t* rep, FILE* fp) {
  int v;

  while ((v = fgetc(fp)) != END_REPLAY) {
	if (v == EOF) {
	  fprintf(stderr, "data file broken\n");
	  exit(1);
	}
	push_replay(rep, v);
  }

  /* JE^ŏ̈ʒuɖ߂Ă */
  init_replay(rep);
}

